package actores.behaviours;


import jade.core.Agent;
import jade.core.AID;
import jade.core.behaviours.*; 
import java.io.*;
import java.util.*;
import java.util.Random;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.SequentialBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.core.behaviours.TickerBehaviour;




public class Coordinador extends Agent
{
	private AID[] listaInvitados; 
	private AID[] listaCamareros; 
	private AID[] enLaFiesta = new AID[11]; // coordinador + 10 invitados
	private AID[] listaOrquesta = new AID[1]; 
	private int numInvitado = 0 ;
	private int hanSaludado = 0 ;
	private String ultimo ;
	
	private boolean policia = false ;
	
	
	private MessageTemplate tratarRespuestas;
	private ArrayList<String> menu = new ArrayList<String>();
	private ArrayList<String> listadoInvitadosCamareros = new ArrayList<String>();
	
	
	protected void setup()
	{	
		// Cada 30 segundos a partir de que venga el primer invitado, se hara una ronda de comida.
		// el camarero asignado sera aleatorio-> num clientes mod 3 , ya que son 3 camareros
		
		SequentialBehaviour secuencia = new SequentialBehaviour();
		
		secuencia.addSubBehaviour	
		(new TickerBehaviour(this, 30000) 
		{
			protected void onTick() 
			{
				
				if ( numInvitado >= 3 && !policia)
				{
					addBehaviour( new atenderCliente() );		
				}
			
       
			} 
		});
		
		secuencia.addSubBehaviour	
		(new WakerBehaviour(this, 2000) 
		{
			protected void onWake() 
			{
				System.out.println("[Coordinador] " + getLocalName() + " esta disponible y organizandolo todo.");
       
			} 
		});
		

		addBehaviour( secuencia );
		
		
		DFAgentDescription listadoInvitados = new DFAgentDescription();
		listadoInvitados.setName( getAID() );
		ServiceDescription sd = new ServiceDescription();
		sd.setType("party-coordinador");
		sd.setName( getLocalName() );
		listadoInvitados.addServices( sd );
		try 
		{
		  DFService.register(this, listadoInvitados);
		}
		catch (FIPAException fe) 
		{
		  fe.printStackTrace();
		}
	
		
		
		
		addBehaviour( new esperarMenu() );		
	
	}//fin setup()

	
	
	/** Atendemos a los invitados mandandoles un camarero **/
	private class atenderCliente extends OneShotBehaviour 
	{
	
				
		public void action()
		{			
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-camarero");
			  template.addServices(sd);
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				
				listaCamareros = new AID[result.length];
				
					for (int i = 0; i < result.length; ++i)
					{
						listaCamareros[i] = result[i].getName();
						
						
						ACLMessage invitacion = new ACLMessage( ACLMessage.AGREE );
						
						invitacion.addReceiver( listaCamareros[i] );
						invitacion.setContentObject( listadoInvitadosCamareros );
						invitacion.setConversationId("invitacion");
						invitacion.setReplyWith("invitacion"+System.currentTimeMillis());
						myAgent.send( invitacion );
					
					}	
								
					
			  }
				catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  
			  catch (Exception ex) 
			  { 
				ex.printStackTrace(); 
			  }
			
			 
		}
		
	}//fin atenderCliente
	
	/** Espero el menu que nos envia el Host de la cena **/
	private class esperarMenu extends CyclicBehaviour 
	{
	
		public void action() 
		{ 
			MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.INFORM);
			ACLMessage mensaje = myAgent.receive(mt);
		  
			if (mensaje != null)
			{
			
				if ( mensaje.getContent().equals("adios"))
				{
					
					hanSaludado++;
					System.out.println( "Numero de gente que se ha saludado a todo el mundo que debia :  " + hanSaludado ) ;
					
					if ( hanSaludado == 10 )
					{
						policia = true ;
						
						addBehaviour( new despedirCamarero() );
						addBehaviour( new pararMusica() );
					}
				}
				else				
				{
					try
					{	
					
						
						System.out.println("\n["+getLocalName() +"] Menu recibido de ...." + mensaje.getSender().getLocalName());
						
										
						menu = (ArrayList<String>) mensaje.getContentObject();					
						
						System.out.println("\n["+getLocalName() +"]============================== Confirmo que el menu es ==============================================");
				
						for ( int i=0 ; i< menu.size() ; i++ )
						{
							System.out.println( i+1 + " " + menu.get( i ) );
						}	
												
						
						addBehaviour( new enviarInvitacion() );
						addBehaviour( new enviarMenu() );
					}
					catch(Exception e)
					{
						e.printStackTrace(); 
					}
				}				
			}
			else
			{
				block();
			}
		}
	  
	}  // Fin esperarMenu
	
	
	/** Damos el chivatazo a los camarero para que se vayan de la fiesta y no se queden al tiroteo **/
	private class despedirCamarero extends OneShotBehaviour 
	{
	
				
		public void action()
		{			
						  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-camarero");
			  template.addServices(sd);
			
				
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				
				listaCamareros = new AID[result.length];
				for (int i = 0; i < result.length; ++i)
				{
					listaCamareros[i] = result[i].getName();
					
					ACLMessage invitacion = new ACLMessage( ACLMessage.REFUSE );
					
					invitacion.addReceiver( listaCamareros[i] );
					invitacion.setContent( ultimo );
					invitacion.setConversationId("invitacion");
					invitacion.setReplyWith("invitacion"+System.currentTimeMillis());
					myAgent.send( invitacion );
					
					doWait ( 2000 ) ;
				}					
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			 
			 
		}
		
	}//fin despedirCamarero
	
	
	/** Cuando entra un invitado en la fiesta, se le ofrece bebida y comida **/
	
	private class buscarCamarero extends OneShotBehaviour 
	{
	
				
		public void action()
		{	 
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-camarero");
			  template.addServices(sd);
			  
			  	Random randomGenerator = new Random();    
				
				int ran = randomGenerator.nextInt(3);
				
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				// System.out.println("[" + getLocalName() + "] Se han encontrado los siguientes camareros:");
				listaCamareros = new AID[result.length];
				for (int i = 0; i < result.length; ++i)
				{
					listaCamareros[i] = result[i].getName();
					// System.out.println( listaCamareros[i].getLocalName() );
				
				}	
				System.out.println("[" + getLocalName() +"] >> [" + listaCamareros[ran].getLocalName() +"] Atiende a este caballero.");
					
					ACLMessage invitacion = new ACLMessage( ACLMessage.REQUEST );
					
					invitacion.addReceiver( listaCamareros[ran] );
					invitacion.setContent( ultimo );
					invitacion.setConversationId("invitacion");
					invitacion.setReplyWith("invitacion"+System.currentTimeMillis());
					myAgent.send( invitacion );
					
					
									
					
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  System.out.println("\n\n======================================================================================");
			 
		}
		
	}//fin buscarCamarero
	
	/** Enviamos la invitacion de nuestra cena a todos los miembros que consideramos invitados **/
	private class enviarInvitacion extends OneShotBehaviour 
	{
	
		public void onStart()
		{
			// agrego al host a la lista de las personas que estan en la fiesta actualmente
			  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-host");
			  template.addServices(sd);
			  
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				
				for (int i = 0; i < result.length; ++i)
				{
					enLaFiesta[numInvitado] = result[i].getName();
					numInvitado++;		
				}
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  
			  catch (Exception ex) 
			  { 
				ex.printStackTrace(); 
			  }

			 
			 doWait(3000);
		}
		
		public void action()
		{
			System.out.println("\n\n===================================Enviando Invitacion===================================");
			
				
			  // Enviamos las invitaciones a los invitados
			  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-guest");
			  template.addServices(sd);
			  
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				System.out.println("[" + getLocalName() + "] Se han encontrado los siguientes invitados en la lista del Host:");
				listaInvitados = new AID[result.length];
				for (int i = 0; i < result.length; ++i)
				{
					listaInvitados[i] = result[i].getName();
					System.out.println("[" + getLocalName() +"] >> [" + listaInvitados[i].getLocalName() +"]");
					
					ACLMessage invitacion = new ACLMessage( ACLMessage.REQUEST );
					
					invitacion.addReceiver( listaInvitados[i] );
					invitacion.setContent( "invitacion" );
					invitacion.setConversationId("invitacion");
					invitacion.setReplyWith("invitacion"+System.currentTimeMillis());
					myAgent.send( invitacion );
					
					doWait(3000);
									
				}	
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  System.out.println("\n\n======================================================================================");
			 
			 doWait(3000);
			 
			 addBehaviour( new EsperarInvitados() );
		}
		
	}//fin enviarInvitacion	
	
	
	/** Que empiece a sonar la musica **/
	private class tocarMusica extends OneShotBehaviour 
	{
		
		public void onStart()
		{
			
			  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-orquesta");
			  template.addServices(sd);
			  
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				if ( result.length != 0 )
				
					listaOrquesta[0] = result[0].getName();						
				
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  
			  catch (Exception ex) 
			  { 
				ex.printStackTrace(); 
			  }		 
			
		}
		
		public void action()
		{
		
			System.out.println("\n\n===================================Haciendo gestos a la orquesta===================================");
			
				
			 
			  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-orquesta");
			  template.addServices(sd);
			  
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				// listaOrquesta = new AID[result.length];
				if ( result.length != 0 )
				{
					listaOrquesta[0] = result[0].getName();
					System.out.println("[" + getLocalName() +"] >> [" + listaOrquesta[0].getLocalName() +"]  Ya podeis empezar a tocar.");
					
					ACLMessage invitacion = new ACLMessage( ACLMessage.REQUEST );
					
					invitacion.addReceiver( listaOrquesta[0] );
					invitacion.setContent( "p.wav" );
					invitacion.setConversationId("invitacion");
					invitacion.setReplyWith("invitacion"+System.currentTimeMillis());
					myAgent.send( invitacion );
					
									
				}	
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  System.out.println("\n\n======================================================================================");			 
			
		}
		
	}//fin tocarMusica
	
			
	/**
	
	pararMusica: Cuando todos se hayan saludado y esten llenos, llamo a la policia
	
	**/
	
	private class pararMusica extends OneShotBehaviour 
	{
		
		public void onStart()
		{
			
			  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-orquesta");
			  template.addServices(sd);
			  
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				if ( result.length != 0 )
				
					listaOrquesta[0] = result[0].getName();						
				
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  
			  catch (Exception ex) 
			  { 
				ex.printStackTrace(); 
			  }		 
			
		}
		
		public void action()
		{
doWait( 5000 ) ;		
			
			
						  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-orquesta");
			  template.addServices(sd);
			  
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				
				if ( result.length != 0 )
				{
					listaOrquesta[0] = result[0].getName();
					
					
					ACLMessage invitacion = new ACLMessage( ACLMessage.REQUEST );
					
					invitacion.addReceiver( listaOrquesta[0] );
					invitacion.setContent( "stop" );
					invitacion.setConversationId("stop");
					invitacion.setReplyWith("stop"+System.currentTimeMillis());				
					
					
					myAgent.send( invitacion );
								
				}	
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  	 
			
		}
		
	}//fin pararMusica
	
	/**  Enviamos el menu a los camareros para que sepan que platos tienen que dar **/
	private class enviarMenu extends OneShotBehaviour 
	{
			
		public void action()
		{
			System.out.println("\n\n===================================Enviando a los camareros===================================");
			
			 			
			  
			  DFAgentDescription template = new DFAgentDescription();
			  ServiceDescription sd = new ServiceDescription();
			  sd.setType("party-camarero");
			  template.addServices(sd);
			  
			  
			  try 
			  {
				DFAgentDescription[] result = DFService.search(myAgent, template); 
				System.out.println("[" + getLocalName() + "] Se han encontrado los siguientes camareros :");
				AID[] listaCamareros = new AID[result.length];
				
				for (int i = 0; i < result.length; ++i)
				{
					listaCamareros[i] = result[i].getName();
					System.out.println("[" + getLocalName() +"] >> [" + listaCamareros[i].getLocalName() +"]");
					
					ACLMessage msgMenu = new ACLMessage( ACLMessage.INFORM ) ;
					
					msgMenu.addReceiver( listaCamareros[i] );
					msgMenu.setContent( "msgMenu" );
					msgMenu.setContentObject( menu ) ;
					msgMenu.setConversationId("msgMenu");
					msgMenu.setReplyWith("msgMenu"+System.currentTimeMillis());
					myAgent.send( msgMenu );
					
					doWait(3000);

									
				}
			  }
			  catch (FIPAException fe)
			  {
				fe.printStackTrace();
			  } 
			  
			  catch (Exception ex) 
			  { 
				ex.printStackTrace(); 
			  }
			  
			  System.out.println("\n\n======================================================================================");
			 
			 
		}
		
	}//fin enviarMenu
	
		
	/**
		El coordinador recibe el mensaje del invitado cuando este llega. 
		Le agrega a la lista de invitados que estan en la fiesta, de forma que el invitado sepa a quien saludar.
	**/
	private class EsperarInvitados extends CyclicBehaviour 
	{
	
		public void action() 
		{
			MessageTemplate mt = MessageTemplate.MatchPerformative(ACLMessage.REQUEST);
			ACLMessage mensaje = myAgent.receive(mt);
		  
			if (mensaje != null)
			{
				try
				{
					// Se ha recibido un mensaje y lo proceso
					
					ACLMessage reply = mensaje.createReply();
					
					System.out.println("[" + getLocalName() +"] Un nuevo invitado ha llegado a la fiesta, reciban a :" + mensaje.getSender().getLocalName() );
					
				
					ultimo = mensaje.getSender().getLocalName() ;
					enLaFiesta[numInvitado] = mensaje.getSender()  ;
					numInvitado++;	
					
					if ( numInvitado == 2 ) 
					{
						addBehaviour ( new tocarMusica() );
						
					}
					if ( numInvitado > 1 ) 
					{
						listadoInvitadosCamareros.add( mensaje.getSender().getLocalName() ) ;
						
					}
					
					

					// System.out.println("\n[" + getLocalName() +"] >> [" + mensaje.getSender().getLocalName() +"] Lista de invitados actuales :");
					// for( int i = 0 ; i < enLaFiesta.length  ; i++)
					// {
						// if (enLaFiesta[i] != null )	
						// {						
							// System.out.println( "[" + getLocalName() +"] " +   enLaFiesta[i].getLocalName()  );
						// }
					// }
					
					reply.setPerformative(ACLMessage.AGREE);
					reply.setContentObject( enLaFiesta ) ;
					
					
					
					myAgent.send(reply);
					
					addBehaviour ( new buscarCamarero() ) ;
					
					
				}			
				catch (Exception ex) 
				{ 
					ex.printStackTrace(); 
				}
				
			}
			else
			{
				block();
			}
		}
		
	  
	}  // Fin Esperar Invitados
		
	protected void takeDown()
	{
		System.out.println("\n[" + getLocalName() + "] abandona la fiesta.\n");
		
	}//fin takeDown()

}